// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
using namespace std;

#define frm setw(8)<<setprecision(2)
int pswap1(double* px, double* py);
int pswap2(double* px, double* py);
int pswap3(double** ppx, double** ppy);
int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
    myofs << "Team 123,   . 18  2008 ." << endl; 
    myofs << "  3-10. " << endl << endl; 
    myofs << " 1.   double." << endl; 
    double x = 123.567;
    double* px = &x;
    myofs << " double x=" << frm << x << ",  double* px=" << px << ",   , *px=" << frm << *px << endl << endl; 
//
    myofs << " 2.  ." << endl; 
    double* px1 = px;
    px1++;
    myofs << "   px++=" << px1 << ",     *(px++)=" << frm << *px1 << endl; 
    myofs << "  (px++)-(px)=" << px1-px << ",    long(px++)-long(px)=" << long(px1)-long(px) << endl; 
    myofs << "    ,    ?  ,  1,  ,  0" << endl << endl; 
  }
  {
    myofs << " 3.  ." << endl; 
    double x = 12.34;
    double* px = &x;
    myofs << " :    x=" << frm << x << ",  px=" << px << ",  *px=" << frm << *px << endl; 
    double* py = px;
    *py += 100;
    myofs << " : x="<< frm << x << ",  px=" << px << ",  *px=" << frm << *px << endl; 
    myofs << " :              py=" << py << ",  *py=" << frm << *py << endl << endl; 
  }
  {
    myofs << " 4.     ." << endl; 
    double x = 23.45;
    double* px = &x;
    double y = *px;
    double* py = &y;
    myofs << " : x=" << frm << x << ",  px=" << px << ",  y=" << frm << y << ",  py=" << py << endl; 
    *py += 100;
    myofs << " : x=" << frm << x << ",  px=" << px << ",  y=" << frm << y << ",  py=" << py << endl << endl; 
  }
  {
    myofs << " 5.    ." << endl; 
    double x = 34.56;
    const double* px = &x;
    double y = 45.67;
    const double* py = &y;
//    *py += 77; // Error!
    myofs << " : x=" << frm << x << ",  const double* px=" << px << "  *px=" << frm << *px << endl; 
    myofs << " : y=" << frm << y << ",  const double* py=" << py << "  *py=" << frm << *py << endl; 
    py = px; // Ok!
    myofs << " : y=" << frm << y << ",  const double* py=" << py << "  *py=" << frm << *py << endl << endl; 
  }
  {
    myofs << " 6.  ." << endl; 
    double x = 34.56;
    const double* px = &x;
    double y = 45.67;
    double* const py = &y;
    myofs << " : x=" << frm << x << ",  px=" << px << "  *px=" << frm << *px << endl; 
    myofs << " : y=" << frm << y << ",  py=" << py << "  *py=" << frm << *py << endl; 
    *py += 77; // Ok!
//    py = px; // Error!
    myofs << " : y=" << frm << y << ",  py=" << py << "  *py=" << frm << *py << endl << endl; 
  }
  {
    myofs << " 7.    ." << endl; 
    const double x = 22.22;
//    double* px = &x; //Error;//    
    const double* px = &x; // Ok!
//    *px+=77; // Error;
    myofs << " x=" << frm << x << ",  px=" << px << ",  *px=" << frm << *px << endl; 
    double y = 33.33;
    double* py = &y;
//    py=&x; ERROR!
//    py=px; ERROR!
    *py = x;
    myofs << " y=" << frm << y << ",  py=" << py << ",  *py=" << frm << *py << endl << endl;; 
  }
  {
    myofs << " 8.   char." << endl; 
    char* p1 = "   1";
    myofs << " p1=" << p1 << ",  *p1=" << *p1 << ",  *p1+1=" << *(p1+1) << ",  *p1+2=" << *(p1+2) << endl; 
    char* p2 = " -";
    myofs << " p2=" << p2 << endl;
//    p2 = p1; ERROR!
    char buf[256];
    char* p3 = "     ";
    strcpy(buf, p3);
    myofs << " buf=" << buf << ",  &buf=" << &buf << endl;
    char* p4 = (char*)(buf);
    myofs << " buf=" << buf << ",  p4=" << p4 << endl << endl;
  }
  {
    myofs << " 9.    ." << endl; 
    double x = 22.22;
    double* px = &x;
    double y = 33.33;
    double* py = &y;
    myofs << " :  x=" << frm << x << ",  px=" << px << ",  *px=" << frm << *px << ",  y=" << frm << y << ",  py=" << py << ",  *py=" << frm << *py << endl;; 
    pswap1(&x, &y); //  ;
    myofs << " 1: x=" << frm << x << ",  px=" << px << ",  *px=" << frm << *px << ",  y=" << frm << y << ",  py=" << py << ",  *py=" << frm << *py << endl;; 
    pswap2(&x, &y); //  ;
    myofs << " 2: x=" << frm << x << ",  px=" << px << ",  *px=" << frm << *px << ",  y=" << frm << y << ",  py=" << py << ",  *py=" << frm << *py << endl;; 
    myofs << " 10.    ." << endl; 
    pswap3(&px, &py); //  ,  ;
    myofs << " 3: x=" << frm << x << ",  px=" << px << ",  *px=" << frm << *px << ",  y=" << frm << y << ",  py=" << py << ",  *py=" << frm << *py << endl;; 
  }
myofs.close();
  return 0;
}

int pswap1(double* px, double* py){
  double z = *px;
  *px = *py;
  *py = z;
  return false;
}
int pswap2(double* px, double* py){
  double* pz = px;
  px = py;
  py = pz;
  return false;
}
int pswap3(double** ppx, double** ppy){
  double* pz = *ppx;
  *ppx = *ppy;
  *ppy = pz;
  return false;
}
